<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:content="http://purl.org/rss/1.0/modules/content/" xmlns:of="scpf.org:office" exclude-result-prefixes="sc sp of">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>
	<xsl:template match="*">
		<xsl:variable name="vUrlPage" select="computeStrDialog('.', concat('lookFor:computeResultWithArguments=act:&amp;codeAgentPrinc=', escapeQueryString(codeAgent(concat('@', switchAxis(codeAgent('//'), 'nav'))))))"/>
		<xsl:variable name="vUrlBase" select="returnFirst(normalize-space(getContent(rootModel(),'rssUrl')),genProp('base.rss.url',''))"/>
		<xsl:variable name="vDate" select="of:postM/sp:date"/>
		<item>
			<title>
				<xsl:value-of select="returnFirst(getFullTitleText(currentModel()),getShortTitleText(currentModel()))" disable-output-escaping="yes"/>
			</title>
			<link>
				<xsl:value-of select="concat($vUrlBase,'/co/',$vUrlPage)"/>
			</link>
			<xsl:if test="string-length($vDate)&gt;0">
				<pubDate>
					<xsl:value-of select="$vDate"/>
				</pubDate>
			</xsl:if>
			<xsl:for-each select="sp:content">
				<content:encoded>
					<xsl:value-of select="getContent(gotoSubModel(.), 'basic')" disable-output-escaping="yes"/>
				</content:encoded>
			</xsl:for-each>
		</item>
	</xsl:template>
</xsl:stylesheet>