<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:lxslt="http://xml.apache.org/xslt" xmlns:redirect="com.scenari.xsldom.xalan.lib.Redirect" xmlns:java="http://xml.apache.org/xslt/java" extension-element-prefixes="redirect java lxslt ">
<xsl:output method="xml" indent="no"/>
<xsl:param name="vDialog"/>
<xsl:param name="vAgent"/>
<xsl:variable name="vIsHomePage" select="//ul[containWord(@class,'outCat')]/li[position()=1 and containWord(@class,'outCat_sel_yes')] or (count(//ul[containWord(@class,'outCat')]) = 0 and //ul[containWord(@class,'outMnu')]/li[position()=1 and containWord(@class,'outMnu_sel_yes')])"/>
<xsl:overlay match="body/scBlock/div">
  <xsl:attribute name="class">tplPgeFra<xsl:if test="$vIsHomePage"> tplPgeHome</xsl:if></xsl:attribute>
</xsl:overlay>

<xsl:template match="@class[containWord(., 'permMargin')]">
	<xsl:attribute name="class"><xsl:value-of select="concat(., if($vIsHomePage,'', ' noIndex'))"/></xsl:attribute>
</xsl:template>
<xsl:overlay match="body">
  <xsl:value-of select="execute(java:append($vBufJs, 'outMgr.init(&quot;ide:menu/chi:ul.mnu_root&quot;);'))"/>
</xsl:overlay>
<xsl:overlay match="a[containWord(@class, 'overLnk')]">
  <xsl:attribute name="onclick">scImgMgr.loading(); return false;</xsl:attribute>
 <xsl:if test="not(containWord(@class, 'overLnkNoTi'))"><xsl:attribute name="title">Agrandir (nouvelle fenêtre)</xsl:attribute></xsl:if>
</xsl:overlay>

<xsl:template match="script[contains(@src,'html5shiv.js')]">
<xsl:variable name="vHtml5shiv"><redirect:serialize omit-xml-declaration="yes" method="html"><xsl:copy><xsl:apply-templates select="@*"/></xsl:copy></redirect:serialize></xsl:variable>
<xsl:comment><![CDATA[[if lt IE 9]>]]><xsl:value-of select="$vHtml5shiv"/><![CDATA[<![endif]]]></xsl:comment>
</xsl:template>

<xsl:overlay match="html">
	<xsl:attribute name="lang"><xsl:value-of select="'fr'"/></xsl:attribute>
</xsl:overlay>



<xsl:variable name="vBufJs" select="java:java.lang.StringBuffer.new()"/>
<xsl:overlay match="body" mode="endBodyTags" priority="100"><xsl:if test="java:length($vBufJs) &gt; 0"><script type="text/javascript"><xsl:value-of select="java:toString($vBufJs)"/></script></xsl:if></xsl:overlay>
	
<xsl:overlay match="body">
  <xsl:value-of select="execute(java:append($vBufJs, 'scImgMgr.init();'))"/>
</xsl:overlay>
<xsl:overlay match="body">
	<xsl:value-of select="execute(java:append($vBufJs, 'tplMgr.saveLocation();'))"/>
</xsl:overlay>

<xsl:variable name="vBasketPool" select="java:java.util.HashMap.new()"/>
	

<xsl:template match="crossRef"/>
<xsl:overlay match="*[crossRef]" priority="1">
<xsl:variable name="vId" select="java:ensureIdOnCurrentResultElt($vDialog, string(crossRef[@prefId]/@prefId))"/>
<xsl:for-each select="crossRef/entry"><xsl:value-of select="java:com.scenari.m.ge.generator.web.CrossRefEntry.addEntry($vDialog, $vId, @keyRef, @value)"/></xsl:for-each>
</xsl:overlay>
	
<xsl:template match="div[contains(@class,'tplFra')]">
	<xsl:variable name="vHasMnu" select="//*[@id='menu']/descendant::text()[string-length(normalize-space())&gt;0] or //*[@id='menu']/descendant::img or //*[@id='menu']/descendant::object"/>
	<xsl:variable name="vHasExt" select="//*[@id='extras']/descendant::text()[string-length(normalize-space())&gt;0] or //*[@id='extras']/descendant::img or //*[@id='extras']/descendant::object"/>
	<xsl:copy>
		<xsl:attribute name="class"><xsl:value-of select="concat(@class, if(not($vHasExt) and not($vHasMnu), ' tplNoSideBars', concat(if(not($vHasExt),' tplNoExtras'), if(not($vHasMnu),' tplNoMenu'))))"/></xsl:attribute>
		<xsl:apply-overlays/>
		<xsl:apply-templates/>
	</xsl:copy>
</xsl:template>

<xsl:overlay match="hx[containWord(ancestor::scBlock[1]/@class, 'bkBase')]">
	<xsl:value-of select="execute(java:ensureIdOnCurrentResultElt($vDialog, string(alphaHash(string(.)))))"/>
</xsl:overlay>
<xsl:template match="@href[ancestor::hx and containWord(ancestor::scBlock[1]/@class, 'bkExtra')]">
	<xsl:attribute name="href">#<xsl:value-of select="alphaHash(string(ancestor::hx))"/></xsl:attribute>
</xsl:template>

<xsl:overlay match="div[containWord(@class,'nodeRoot')]">
  <xsl:attribute name="class">
    <xsl:value-of select="concat(@class,' nodeDepth_',count(ancestor::div[containWord(@class,'nodeChildren')]))"/>
  </xsl:attribute>
</xsl:overlay>
<xsl:overlay match="scBasket">
	<xsl:if test="count(//scTooltip)&gt;0"><hr class="hidden"/><strong class="hidden">Notes &amp; renvois :</strong></xsl:if>
</xsl:overlay>

<xsl:overlay match="a[containWord(@class, 'galPvLnk')]">
  <xsl:attribute name="onclick">scImgMgr.loading(); return false;</xsl:attribute>
</xsl:overlay>
<xsl:overlay match="body">
  <xsl:value-of select="execute(java:append($vBufJs, 'treeMgr.init();'))"/>
</xsl:overlay>


<xsl:template match="alternative"><xsl:apply-templates/></xsl:template>
<xsl:template match="@lookForAlt"><xsl:attribute name="alt"><xsl:value-of select="si(.='', ancestor::alternative/@alt, .)"/></xsl:attribute></xsl:template>	
	
<xsl:overlay match="div[containWord( @class, 'tplFra')]">
   <xsl:apply-templates mode="index"/>
</xsl:overlay>
<xsl:template match="div[containWord(@class,'permMargin')]" mode="index">
   <xsl:if test="$vIsHomePage">
      <xsl:apply-templates mode="index"/>
   </xsl:if>
</xsl:template>
<xsl:template match="*[containWord(@class,'noIndex')]" mode="index"/>
<xsl:template match="scTooltipTitle" mode="index"/>
<xsl:template match="scTooltipContent" mode="index"/>
<xsl:template match="addAttribute" mode="index"/>
<xsl:template match="script" mode="index"/>
<xsl:template match="noscript" mode="index"/>
<xsl:template match="text()" mode="index">
  <xsl:value-of select="execute(java:com.scenari.m.ge.pages.SearchIndexPage.indexText($vDialog, 'index', 'indexBuffer', 'fullText', string(.)))"/>
</xsl:template>
<xsl:template match="*" mode="index">
  <xsl:apply-templates mode="index"/>
</xsl:template>


<xsl:overlay match="/">
<xsl:for-each select="//scBasket">
<xsl:variable name="vKey" select="string(@key)"/>
<xsl:variable name="vUnicity" select="java:java.util.HashSet.new()"/>
<xsl:value-of select="java:put($vBasketPool, $vKey, lxslt:nodeset(//scTooltip[@basketKey=$vKey][java:add($vUnicity, string(@itemKey))]))"/> 
</xsl:for-each>	
</xsl:overlay>
<xsl:template match="scBasket">
<xsl:variable name="vClass" select="@widgetClass"/>
<xsl:variable name="vKey" select="string(@key)"/>
<xsl:variable name="vHasElts" select="boolean(java:get($vBasketPool, $vKey))"/>
<xsl:if test="$vHasElts or @suppressIfEmpty = 'no'">
<xsl:choose>
<xsl:when test="scBlock">
<xsl:element name="{returnFirst(scBlock/@tagName, 'div')}">
<xsl:attribute name="class"><xsl:value-of select="concat(@class,' ',$vClass)"/></xsl:attribute>
<xsl:variable name="vCount" select="count(ancestor::scBlock)+1"/>
<xsl:variable name="vMaxHx"><xsl:call-template name="maxHeadingNumber"/></xsl:variable>
<xsl:element name="{concat('h', si($vCount &gt; $vMaxHx, $vMaxHx, $vCount))}">
<xsl:attribute name="class"><xsl:value-of select="addSuffixOnWords($vClass, '_ti')"/></xsl:attribute>
<xsl:apply-templates select="scBlock/node()"/>
</xsl:element>
<xsl:apply-templates select="." mode="scBasketList"/>
</xsl:element>
</xsl:when>
<xsl:when test="scBasketTitle">
<div>
<xsl:attribute name="class"><xsl:value-of select="concat(@class,' ',$vClass)"/></xsl:attribute>
<div>
<xsl:attribute name="class"><xsl:value-of select="addSuffixOnWords($vClass, '_ti')"/></xsl:attribute>
<xsl:apply-templates select="scBasketTitle/node()"/>
</div>
<xsl:apply-templates select="." mode="scBasketList"/>
</div>
</xsl:when>
<xsl:otherwise>
<xsl:apply-templates select="." mode="scBasketList"/>
</xsl:otherwise>
</xsl:choose>
</xsl:if>
</xsl:template>
<xsl:template match="scBasket" mode="scBasketList">
<xsl:variable name="vClass" select="@widgetClass"/>
<xsl:variable name="vKey" select="string(@key)"/>
<xsl:variable name="vChiTagName" select="si(@tagName='div','div','li')"/>
<xsl:element name="{@tagName}">
<xsl:choose>
<xsl:when test="scBlock|scBasketTitle">
<xsl:attribute name="class"><xsl:value-of select="addSuffixOnWords($vClass, '_li')"/></xsl:attribute>
<xsl:attribute name="data-titled-basket">true</xsl:attribute>
</xsl:when>
<xsl:otherwise>
<xsl:attribute name="class"><xsl:value-of select="concat(@class,' ',$vClass)"/></xsl:attribute>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="@sort='byTitle'">
<xsl:for-each select="java:get($vBasketPool, $vKey)">
<xsl:sort select="scTooltipTitle" data-type="text"/>
<xsl:apply-templates select="." mode="scBasketItem">
<xsl:with-param name="vClass" select="$vClass"/>
<xsl:with-param name="vChiTagName" select="$vChiTagName"/>
</xsl:apply-templates>
</xsl:for-each>
</xsl:when>
<xsl:when test="@sort='byContent'">
<xsl:for-each select="java:get($vBasketPool, $vKey)">
<xsl:sort select="scTooltipContent" data-type="text"/>
<xsl:apply-templates select="." mode="scBasketItem">
<xsl:with-param name="vClass" select="$vClass"/>
<xsl:with-param name="vChiTagName" select="$vChiTagName"/>
</xsl:apply-templates>
</xsl:for-each>
</xsl:when>
<xsl:otherwise>
<xsl:for-each select="java:get($vBasketPool, $vKey)">
<xsl:apply-templates select="." mode="scBasketItem">
<xsl:with-param name="vClass" select="$vClass"/>
<xsl:with-param name="vChiTagName" select="$vChiTagName"/>
</xsl:apply-templates>
</xsl:for-each>
</xsl:otherwise>
</xsl:choose>
</xsl:element>
</xsl:template>
<xsl:template match="*" mode="scBasketItem">
<xsl:param name="vClass"/>
<xsl:param name="vChiTagName"/>
<xsl:choose>
<xsl:when test="local-name() = 'scTooltip'">
<xsl:variable name="vIdInBskt" select="concat(@basketKey, generate-id(.))"/>
<xsl:element name="{$vChiTagName}">
<xsl:attribute name="class"><xsl:value-of select="addSuffixOnWords($vClass, '_it')"/></xsl:attribute>
<xsl:attribute name="id"><xsl:value-of select="$vIdInBskt"/></xsl:attribute>
<div class="{addSuffixOnWords($vClass, '_itti')}">
<xsl:choose>
<xsl:when test="scTooltipTitle"><xsl:apply-templates select="scTooltipTitle/node()"/></xsl:when>
<xsl:otherwise><xsl:attribute name="style">display:none;</xsl:attribute></xsl:otherwise>
</xsl:choose>
</div>
<div class="{addSuffixOnWords($vClass, '_itco')}">
<xsl:choose>
<xsl:when test="scTooltipContent"><xsl:apply-templates select="scTooltipContent/node()"/></xsl:when>
<xsl:otherwise><xsl:attribute name="style">display:none;</xsl:attribute></xsl:otherwise>
</xsl:choose>
</div>
</xsl:element>		
</xsl:when>
</xsl:choose>
</xsl:template>
	
<xsl:overlay match="table[contains(@class, 'layout')]">
  <xsl:attribute name="role">presentation</xsl:attribute>
</xsl:overlay>

<xsl:template match="ifOptContent"><xsl:if test="descendant::text()[string-length(normalize-space())&gt;0][count(ancestor::statMgr) = 0] or descendant::img[count(ancestor::statMgr) = 0] or descendant::object[count(ancestor::statMgr) = 0]"><xsl:apply-templates/></xsl:if></xsl:template>
<xsl:template match="ifOptHead"><xsl:if test="descendant::text()[string-length(normalize-space())&gt;0] or descendant::img or descendant::object or descendant::optScSearch"><xsl:apply-templates/></xsl:if></xsl:template>

<xsl:template match="@sc-role"><xsl:attribute name="role"><xsl:value-of select="."/></xsl:attribute></xsl:template>
	

<xsl:overlay match="*[parent::scTooltip/@basketKey and not(starts-with(local-name(),'scTooltip'))]" priority="1">
<xsl:variable name="vIdAnc" select="java:ensureIdOnCurrentResultElt($vDialog)"/>
<xsl:variable name="vTT" select="parent::scTooltip"/>
<xsl:variable name="vBasketKey" select="string($vTT/@basketKey)"/>
<xsl:variable name="vItemKey" select="string($vTT/@itemKey)"/>
<xsl:variable name="vIdInBskt" select="concat($vBasketKey, generate-id(java:get($vBasketPool, $vBasketKey)[@itemKey = $vItemKey][1]))"/>
<xsl:variable name="vTrigger">
<xsl:choose>
<xsl:when test="boolean(descendant::a | ancestor::a) and $vTT/@trigger='onclick'">onmouseover</xsl:when>
<xsl:otherwise><xsl:value-of select="$vTT/@trigger"/></xsl:otherwise>
</xsl:choose>
</xsl:variable>
<xsl:if test="$vTT/@render = 'asTooltip' and boolean(//scBasket[@key=$vBasketKey])">
<xsl:value-of select="execute(java:append($vBufJs, concat('scTooltipMgr.registerTooltip(&quot;',$vIdAnc,'&quot;,&quot;',$vIdInBskt,'&quot;,&quot;',$vTrigger,'&quot;,&quot;',$vTT/@class,'&quot;,&quot;',$vTT/@classRoot,'&quot;,{',si($vTT/@basketLnk='no','NOREF:true,'),$vTT/@options,'});')))"/>
</xsl:if>
</xsl:overlay>
<xsl:template match="scTooltip">
<xsl:variable name="vKey" select="string(@basketKey)"/>
<xsl:choose>
<xsl:when test="@basketKey and boolean(//scBasket[@key=$vKey])">
<xsl:variable name="vItemKey" select="string(@itemKey)"/>
<xsl:variable name="vIdInBskt" select="concat($vKey, generate-id(java:get($vBasketPool, $vKey)[@itemKey = $vItemKey][1]))"/>
<xsl:variable name="vEltRank"><xsl:for-each select="java:get($vBasketPool, $vKey)"><xsl:value-of select="si(@itemKey = $vItemKey, position(), '')"/></xsl:for-each></xsl:variable>
<xsl:variable name="vRefAnc" select="si(//scBasket[@key=$vKey][1]/@tagName = 'ol',$vEltRank,'*')"/>
<xsl:for-each select="child::*[not(starts-with(local-name(),'scTooltip'))]">
<xsl:variable name="vTagName">
<xsl:choose>
<xsl:when test="boolean(descendant::a | ancestor::a)">span</xsl:when>
<xsl:otherwise><xsl:value-of select="local-name()"/></xsl:otherwise>
</xsl:choose>
</xsl:variable>
<xsl:element name="{$vTagName}">
<xsl:for-each select="@*">
<xsl:apply-templates select="."/>
</xsl:for-each>
<xsl:if test="$vTagName = 'a' and @href = '#'"><xsl:attribute name="href">#<xsl:value-of select="$vIdInBskt"/></xsl:attribute></xsl:if>
<xsl:apply-overlays/>
<xsl:apply-templates/>
</xsl:element>
</xsl:for-each>
<xsl:if test="not(@basketLnk='no')">
<sup class="{addSuffixOnWords(@class, '_ref')}">
<xsl:choose>
<xsl:when test="boolean(ancestor::a)"><span>[</span><xsl:value-of select="$vRefAnc"/><span>]</span></xsl:when>
<xsl:otherwise><a href="#{$vIdInBskt}"><span>[</span><xsl:value-of select="$vRefAnc"/><span>]</span></a></xsl:otherwise>
</xsl:choose>
</sup>
</xsl:if>
</xsl:when>
<xsl:otherwise>
<xsl:variable name="vTTTitle"><redirect:serialize omit-xml-declaration="yes" method="html"><xsl:apply-templates select="scTooltipTitle/node()"/></redirect:serialize></xsl:variable>
<xsl:variable name="vTTContent"><redirect:serialize omit-xml-declaration="yes" method="html"><xsl:apply-templates select="scTooltipContent/node()"/></redirect:serialize></xsl:variable>
<xsl:variable name="vTTTrigger" select="@trigger"/>
<xsl:variable name="vTTAttr">return scTooltipMgr.showTooltip(this,event,&quot;<xsl:value-of select="chaineProtegeJs(normalize-space($vTTContent))"/>&quot;,&quot;<xsl:value-of select="chaineProtegeJs(normalize-space($vTTTitle))"/>&quot;,&quot;<xsl:value-of select="@class"/>&quot;,&quot;<xsl:value-of select="@classRoot"/>&quot;,{<xsl:value-of select="@options"/>});</xsl:variable>
<xsl:for-each select="child::*[not(starts-with(local-name(),'scTooltip'))]">
<xsl:variable name="vTagName">
<xsl:choose>
<xsl:when test="boolean(descendant::a | ancestor::a)">span</xsl:when>
<xsl:otherwise><xsl:value-of select="local-name()"/></xsl:otherwise>
</xsl:choose>
</xsl:variable>
<xsl:element name="{$vTagName}">
<xsl:attribute name="{si((boolean(descendant::a | ancestor::a)) and $vTTTrigger='onclick','onmouseover',$vTTTrigger)}"><xsl:value-of select="$vTTAttr"/></xsl:attribute>
<xsl:apply-templates select="@*"/>
<xsl:apply-overlays/>
<xsl:apply-templates/>
</xsl:element>
</xsl:for-each>
</xsl:otherwise>
</xsl:choose>
</xsl:template>
	
<xsl:template match="ul[contains(@id,'accessibility')]">
	<xsl:variable name="vHasMnu" select="//*[@id='menu']/descendant::text()[string-length(normalize-space())&gt;0] or //*[@id='menu']/descendant::img or //* [@id='menu']/descendant::object"/>
	<xsl:variable name="vHasNav" select="//*[@id='navigation']/descendant::text()[string-length(normalize-space())&gt;0] or //*[@id='navigation']/descendant::img or //*[@id='navigation']/descendant::object"/>
	<xsl:variable name="vHasExt" select="//*[@id='extras']/descendant::text()[string-length(normalize-space())&gt;0] or //*[@id='extras']/descendant::img or //*[@id='extras']/descendant::object"/>
	<xsl:copy>
		<xsl:apply-templates select="@*"/>
		<xsl:apply-overlays/>
		<xsl:apply-templates select="*[contains(@class, 'Content')]"/>
		<xsl:if test="$vHasMnu">
			<xsl:apply-templates select="*[contains(@class, 'Menu')]"/>
		</xsl:if>
		<xsl:if test="$vHasNav">
			<xsl:apply-templates select="*[contains(@class, 'Nav')]"/>
		</xsl:if>
		<xsl:if test="$vHasExt">
			<xsl:apply-templates select="*[contains(@class, 'Extras')]"/>
		</xsl:if>
	</xsl:copy>
</xsl:template>

<xsl:overlay match="body" priority="100">
	<xsl:value-of select="execute(java:append($vBufJs, 'tplMgr.init();'))"/>
</xsl:overlay>

<xsl:template match="scBlock"><xsl:element name="{returnFirst(@tagName, 'div')}"><xsl:apply-templates select="@*"/><xsl:apply-overlays/><xsl:apply-templates/></xsl:element></xsl:template>
<xsl:template match="scBlock/@noLocalOutline"/>
<xsl:template match="scBlock/@tagName"/>
<xsl:template match="scBlockTitle"/>
	

<xsl:template match="/"><xsl:apply-overlays/><xsl:apply-templates select="node()"/></xsl:template>
<xsl:template match="head">
<xsl:copy>
<xsl:apply-templates select="@*"/>
<xsl:apply-overlays select="." mode="startHeadTags"/>
<xsl:apply-overlays/>
<xsl:apply-templates/>
<xsl:apply-overlays select="." mode="endHeadTags"/>
</xsl:copy>
</xsl:template>
<xsl:template match="body">
<xsl:copy>
<xsl:apply-templates select="@*"/>
<xsl:apply-overlays select="." mode="startBodyTags"/>
<xsl:apply-overlays select="." mode="startTags"/>
<xsl:apply-overlays/>
<xsl:apply-templates/>
<xsl:apply-overlays select="." mode="endTags"/>
<xsl:apply-overlays select="." mode="endBodyTags"/>
</xsl:copy>
</xsl:template>
<xsl:template match="zoneContent"><xsl:apply-overlays/><xsl:apply-templates/></xsl:template>
<xsl:template match="ifText"><xsl:if test="descendant::text()[string-length(normalize-space())&gt;0] | descendant::img | descendant::object | descendant::input"><xsl:apply-templates/></xsl:if></xsl:template>
<xsl:template name="maxHeadingNumber">6</xsl:template>
<xsl:template match="hx"><xsl:variable name="vCount" select="count(ancestor::scBlock)"/><xsl:variable name="vMaxHx"><xsl:call-template name="maxHeadingNumber"/></xsl:variable><xsl:element name="{concat('h', si($vCount &gt; $vMaxHx, $vMaxHx, $vCount))}"><xsl:apply-templates select="@*"/><xsl:apply-overlays/><xsl:apply-templates/></xsl:element></xsl:template>
<xsl:template match="addAttribute">
<xsl:variable name="vAttCo"><xsl:choose><xsl:when test="@filter='textOnly'"><xsl:value-of select="normalize-space(.)"/></xsl:when><xsl:otherwise><redirect:serialize omit-xml-declaration="yes"><xsl:value-of select="."/></redirect:serialize></xsl:otherwise></xsl:choose></xsl:variable>
<xsl:choose>
<xsl:when test="@name = 'lookForAlt'">
<xsl:attribute name="alt"><xsl:value-of select="si(string($vAttCo)='', ancestor::alternative/@alt, $vAttCo)" disable-output-escaping="yes"/></xsl:attribute>
</xsl:when>
<xsl:otherwise>
<xsl:attribute name="{@name}"><xsl:value-of select="$vAttCo" disable-output-escaping="yes"/></xsl:attribute>
</xsl:otherwise>
</xsl:choose>
</xsl:template>
	
<xsl:overlay match="a[contains(@class, 'txt_url_ul') or contains(@class, 'txt_ref_ul')]">
	<xsl:if test="count(span/descendant::text()[string-length(normalize-space())&gt;0])=0 and boolean(span/descendant::img)"><xsl:attribute name="class"><xsl:value-of select="@class"/> txt_ul_imgOnly</xsl:attribute></xsl:if>
</xsl:overlay>
<xsl:overlay match="body" mode="endTags"><xsl:copy-of select="/descendant::endbody/*"/></xsl:overlay>
<xsl:template match="endbody"/>
	<xsl:template match="* | processing-instruction() | comment()"><xsl:copy><xsl:apply-templates select="@*"/><xsl:apply-overlays/><xsl:apply-templates/></xsl:copy></xsl:template>
	<xsl:template match="@* | text()"><xsl:copy/></xsl:template>
</xsl:stylesheet>
