<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:lxslt="http://xml.apache.org/xslt" xmlns:redirect="com.scenari.xsldom.xalan.lib.Redirect" xmlns:java="http://xml.apache.org/xslt/java" xmlns:content="http://purl.org/rss/1.0/modules/content/" extension-element-prefixes="redirect java lxslt ">
<xsl:output method="xml" indent="no"/>
<xsl:param name="vDialog"/>
<xsl:param name="vAgent"/>
<xsl:template match='*[local-name() = "encoded"]'>
	<xsl:copy>
		<xsl:text disable-output-escaping="yes">&lt;![CDATA[</xsl:text>
		<xsl:apply-templates/>
		<xsl:text disable-output-escaping="yes">]]&gt;</xsl:text>
	</xsl:copy>
</xsl:template>

<xsl:variable name="vBaseURL" select="//channel/link/text()"/>
<xsl:template match="img[contains(@class,'binImg')]/@src">
	<xsl:attribute name="src"><xsl:value-of select="concat($vBaseURL, '/co/', .)"/></xsl:attribute>
</xsl:template>
<xsl:template match="a[contains(@class,'sub_a')]/@href">
	<xsl:attribute name="href"><xsl:value-of select="concat($vBaseURL, '/co/', .)"/></xsl:attribute>
</xsl:template>
<xsl:template match="a[contains(@class,'overLnk')]/@href">
	<xsl:attribute name="href"><xsl:value-of select="concat($vBaseURL, '/co/', .)"/></xsl:attribute>
</xsl:template>
<xsl:overlay match="a[containWord(@class, 'overLnk')]" priority="10"/>


<xsl:overlay match="*[parent::scTooltip/@basketKey and not(starts-with(local-name(),'scTooltip'))]" priority="1">
<xsl:variable name="vIdAnc" select="java:ensureIdOnCurrentResultElt($vDialog)"/>
<xsl:variable name="vTT" select="parent::scTooltip"/>
<xsl:variable name="vBasketKey" select="string($vTT/@basketKey)"/>
<xsl:variable name="vItemKey" select="string($vTT/@itemKey)"/>
<xsl:variable name="vIdInBskt" select="concat($vBasketKey, generate-id(java:get($vBasketPool, $vBasketKey)[@itemKey = $vItemKey][1]))"/>
<xsl:variable name="vTrigger">
<xsl:choose>
<xsl:when test="boolean(descendant::a | ancestor::a) and $vTT/@trigger='onclick'">onmouseover</xsl:when>
<xsl:otherwise><xsl:value-of select="$vTT/@trigger"/></xsl:otherwise>
</xsl:choose>
</xsl:variable>
<xsl:if test="$vTT/@render = 'asTooltip' and boolean(//scBasket[@key=$vBasketKey])">
<xsl:value-of select="execute(java:append($vBufJs, concat('scTooltipMgr.registerTooltip(&quot;',$vIdAnc,'&quot;,&quot;',$vIdInBskt,'&quot;,&quot;',$vTrigger,'&quot;,&quot;',$vTT/@class,'&quot;,&quot;',$vTT/@classRoot,'&quot;,{',si($vTT/@basketLnk='no','NOREF:true,'),$vTT/@options,'});')))"/>
</xsl:if>
</xsl:overlay>
<xsl:template match="scTooltip">
<xsl:variable name="vKey" select="string(@basketKey)"/>
<xsl:choose>
<xsl:when test="@basketKey and boolean(//scBasket[@key=$vKey])">
<xsl:variable name="vItemKey" select="string(@itemKey)"/>
<xsl:variable name="vIdInBskt" select="concat($vKey, generate-id(java:get($vBasketPool, $vKey)[@itemKey = $vItemKey][1]))"/>
<xsl:variable name="vEltRank"><xsl:for-each select="java:get($vBasketPool, $vKey)"><xsl:value-of select="si(@itemKey = $vItemKey, position(), '')"/></xsl:for-each></xsl:variable>
<xsl:variable name="vRefAnc" select="si(//scBasket[@key=$vKey][1]/@tagName = 'ol',$vEltRank,'*')"/>
<xsl:for-each select="child::*[not(starts-with(local-name(),'scTooltip'))]">
<xsl:variable name="vTagName">
<xsl:choose>
<xsl:when test="boolean(descendant::a | ancestor::a)">span</xsl:when>
<xsl:otherwise><xsl:value-of select="local-name()"/></xsl:otherwise>
</xsl:choose>
</xsl:variable>
<xsl:element name="{$vTagName}">
<xsl:for-each select="@*">
<xsl:apply-templates select="."/>
</xsl:for-each>
<xsl:if test="$vTagName = 'a' and @href = '#'"><xsl:attribute name="href">#<xsl:value-of select="$vIdInBskt"/></xsl:attribute></xsl:if>
<xsl:apply-overlays/>
<xsl:apply-templates/>
</xsl:element>
</xsl:for-each>
<xsl:if test="not(@basketLnk='no')">
<sup class="{addSuffixOnWords(@class, '_ref')}">
<xsl:choose>
<xsl:when test="boolean(ancestor::a)"><span>[</span><xsl:value-of select="$vRefAnc"/><span>]</span></xsl:when>
<xsl:otherwise><a href="#{$vIdInBskt}"><span>[</span><xsl:value-of select="$vRefAnc"/><span>]</span></a></xsl:otherwise>
</xsl:choose>
</sup>
</xsl:if>
</xsl:when>
<xsl:otherwise>
<xsl:variable name="vTTTitle"><redirect:serialize omit-xml-declaration="yes" method="html"><xsl:apply-templates select="scTooltipTitle/node()"/></redirect:serialize></xsl:variable>
<xsl:variable name="vTTContent"><redirect:serialize omit-xml-declaration="yes" method="html"><xsl:apply-templates select="scTooltipContent/node()"/></redirect:serialize></xsl:variable>
<xsl:variable name="vTTTrigger" select="@trigger"/>
<xsl:variable name="vTTAttr">return scTooltipMgr.showTooltip(this,event,&quot;<xsl:value-of select="chaineProtegeJs(normalize-space($vTTContent))"/>&quot;,&quot;<xsl:value-of select="chaineProtegeJs(normalize-space($vTTTitle))"/>&quot;,&quot;<xsl:value-of select="@class"/>&quot;,&quot;<xsl:value-of select="@classRoot"/>&quot;,{<xsl:value-of select="@options"/>});</xsl:variable>
<xsl:for-each select="child::*[not(starts-with(local-name(),'scTooltip'))]">
<xsl:variable name="vTagName">
<xsl:choose>
<xsl:when test="boolean(descendant::a | ancestor::a)">span</xsl:when>
<xsl:otherwise><xsl:value-of select="local-name()"/></xsl:otherwise>
</xsl:choose>
</xsl:variable>
<xsl:element name="{$vTagName}">
<xsl:attribute name="{si((boolean(descendant::a | ancestor::a)) and $vTTTrigger='onclick','onmouseover',$vTTTrigger)}"><xsl:value-of select="$vTTAttr"/></xsl:attribute>
<xsl:apply-templates select="@*"/>
<xsl:apply-overlays/>
<xsl:apply-templates/>
</xsl:element>
</xsl:for-each>
</xsl:otherwise>
</xsl:choose>
</xsl:template>
	

<xsl:variable name="vBasketPool" select="java:java.util.HashMap.new()"/>
	

<xsl:template match="scBlock"><xsl:element name="{returnFirst(@tagName, 'div')}"><xsl:apply-templates select="@*"/><xsl:apply-overlays/><xsl:apply-templates/></xsl:element></xsl:template>
<xsl:template match="scBlock/@noLocalOutline"/>
<xsl:template match="scBlock/@tagName"/>
<xsl:template match="scBlockTitle"/>
	

<xsl:template match="/"><xsl:apply-overlays/><xsl:apply-templates select="node()"/></xsl:template>
<xsl:template match="head">
<xsl:copy>
<xsl:apply-templates select="@*"/>
<xsl:apply-overlays select="." mode="startHeadTags"/>
<xsl:apply-overlays/>
<xsl:apply-templates/>
<xsl:apply-overlays select="." mode="endHeadTags"/>
</xsl:copy>
</xsl:template>
<xsl:template match="body">
<xsl:copy>
<xsl:apply-templates select="@*"/>
<xsl:apply-overlays select="." mode="startBodyTags"/>
<xsl:apply-overlays select="." mode="startTags"/>
<xsl:apply-overlays/>
<xsl:apply-templates/>
<xsl:apply-overlays select="." mode="endTags"/>
<xsl:apply-overlays select="." mode="endBodyTags"/>
</xsl:copy>
</xsl:template>
<xsl:template match="zoneContent"><xsl:apply-overlays/><xsl:apply-templates/></xsl:template>
<xsl:template match="ifText"><xsl:if test="descendant::text()[string-length(normalize-space())&gt;0] | descendant::img | descendant::object | descendant::input"><xsl:apply-templates/></xsl:if></xsl:template>
<xsl:template name="maxHeadingNumber">6</xsl:template>
<xsl:template match="hx"><xsl:variable name="vCount" select="count(ancestor::scBlock)"/><xsl:variable name="vMaxHx"><xsl:call-template name="maxHeadingNumber"/></xsl:variable><xsl:element name="{concat('h', si($vCount &gt; $vMaxHx, $vMaxHx, $vCount))}"><xsl:apply-templates select="@*"/><xsl:apply-overlays/><xsl:apply-templates/></xsl:element></xsl:template>
<xsl:template match="addAttribute">
<xsl:variable name="vAttCo"><xsl:choose><xsl:when test="@filter='textOnly'"><xsl:value-of select="normalize-space(.)"/></xsl:when><xsl:otherwise><redirect:serialize omit-xml-declaration="yes"><xsl:value-of select="."/></redirect:serialize></xsl:otherwise></xsl:choose></xsl:variable>
<xsl:choose>
<xsl:when test="@name = 'lookForAlt'">
<xsl:attribute name="alt"><xsl:value-of select="si(string($vAttCo)='', ancestor::alternative/@alt, $vAttCo)" disable-output-escaping="yes"/></xsl:attribute>
</xsl:when>
<xsl:otherwise>
<xsl:attribute name="{@name}"><xsl:value-of select="$vAttCo" disable-output-escaping="yes"/></xsl:attribute>
</xsl:otherwise>
</xsl:choose>
</xsl:template>
	
<xsl:overlay match="a[containWord(@class, 'overLnk')]">
  <xsl:attribute name="onclick">scImgMgr.loading(); return false;</xsl:attribute>
 <xsl:if test="not(containWord(@class, 'overLnkNoTi'))"><xsl:attribute name="title">Agrandir (nouvelle fenêtre)</xsl:attribute></xsl:if>
</xsl:overlay>


<xsl:template match="alternative"><xsl:apply-templates/></xsl:template>
<xsl:template match="@lookForAlt"><xsl:attribute name="alt"><xsl:value-of select="si(.='', ancestor::alternative/@alt, .)"/></xsl:attribute></xsl:template>	
	

<xsl:template match="crossRef"/>
<xsl:overlay match="*[crossRef]" priority="1">
<xsl:variable name="vId" select="java:ensureIdOnCurrentResultElt($vDialog, string(crossRef[@prefId]/@prefId))"/>
<xsl:for-each select="crossRef/entry"><xsl:value-of select="java:com.scenari.m.ge.generator.web.CrossRefEntry.addEntry($vDialog, $vId, @keyRef, @value)"/></xsl:for-each>
</xsl:overlay>
	

<xsl:variable name="vBufJs" select="java:java.lang.StringBuffer.new()"/>
<xsl:overlay match="body" mode="endBodyTags" priority="100"><xsl:if test="java:length($vBufJs) &gt; 0"><script type="text/javascript"><xsl:value-of select="java:toString($vBufJs)"/></script></xsl:if></xsl:overlay>
	
<xsl:overlay match="body">
  <xsl:value-of select="execute(java:append($vBufJs, 'scImgMgr.init();'))"/>
</xsl:overlay>
	<xsl:template match="* | processing-instruction() | comment()"><xsl:copy><xsl:apply-templates select="@*"/><xsl:apply-overlays/><xsl:apply-templates/></xsl:copy></xsl:template>
	<xsl:template match="@* | text()"><xsl:copy/></xsl:template>
</xsl:stylesheet>
